clang-tools 3.8.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | List of all members
clang::tidy::readability::IdentifierNamingCheck Class Reference

Checks for identifiers naming style mismatch. More...

`#include <IdentifierNamingCheck.h>`

Inheritance diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]
Collaboration diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]

## Classes
struct | NamingCheckFailure
| Holds an identifier name check failure, tracking the kind of the identifer, its possible fixup and the starting locations of all the idenfiier usages. More...
struct | NamingStyle

## Public Types
enum | CaseType { CT_AnyCase = 0, CT_LowerCase, CT_CamelBack, CT_UpperCase, CT_CamelCase }
typedef llvm::DenseMap< const NamedDecl *, NamingCheckFailure > | NamingCheckFailureMap

## Public Member Functions
| IdentifierNamingCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register ASTMatchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | onEndOfTranslationUnit () override
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for identifiers naming style mismatch.

This check will try to enforce coding guidelines on the identifiers naming. It supports `lower_case`, `UPPER_CASE`, `camelBack` and `CamelCase` casing and tries to convert from one to another if a mismatch is detected.

It also supports a fixed prefix and suffix that will be prepended or appended to the identifiers, regardless of the casing.

Many configuration options are available, in order to be able to create different rules for different kind of identifier. In general, the rules are falling back to a more generic rule if the specific case is not configured.

Definition at line 32 of file IdentifierNamingCheck.h.

## Member Typedef Documentation

typedef llvm::DenseMap<const NamedDecl *, NamingCheckFailure> clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailureMap

Definition at line 85 of file IdentifierNamingCheck.h.

## Member Enumeration Documentation

enum clang::tidy::readability::IdentifierNamingCheck::CaseType

Enumerator
CT_AnyCase |
CT_LowerCase |
CT_CamelBack |
CT_UpperCase |
CT_CamelCase |

Definition at line 41 of file IdentifierNamingCheck.h.

## Constructor & Destructor Documentation

clang::tidy::readability::IdentifierNamingCheck::IdentifierNamingCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 86 of file IdentifierNamingCheck.cpp.

References CT_AnyCase, CT_CamelBack, CT_CamelCase, CT_LowerCase, CT_UpperCase, clang::tidy::OptionsView::get(), clang::tidy::ClangTidyCheck::Options, and clang::tidy::readability::StyleNames.

## Member Function Documentation

void clang::tidy::readability::IdentifierNamingCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 521 of file IdentifierNamingCheck.cpp.

References clang::tidy::readability::addUsage(), CT_LowerCase, clang::tidy::readability::findStyleKind(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::Fixup, clang::tidy::readability::fixupWithCase(), clang::tidy::readability::fixupWithStyle(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::KindName, Loc, clang::tidy::readability::matchesStyle(), Name, Range, clang::tidy::readability::SK_Invalid, and clang::tidy::readability::StyleNames.

void clang::tidy::readability::IdentifierNamingCheck::onEndOfTranslationUnit | ( |  | ) |
| override

Definition at line 655 of file IdentifierNamingCheck.cpp.

References clang::tidy::ClangTidyCheck::diag(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::Fixup, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::KindName, Loc, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::RawUsageLocs, and clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::ShouldFix.

void clang::tidy::readability::IdentifierNamingCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register ASTMatchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 138 of file IdentifierNamingCheck.cpp.

void clang::tidy::readability::IdentifierNamingCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 108 of file IdentifierNamingCheck.cpp.

References CT_AnyCase, CT_CamelBack, CT_CamelCase, CT_LowerCase, CT_UpperCase, clang::tidy::ClangTidyCheck::Options, clang::tidy::readability::SK_Count, clang::tidy::OptionsView::store(), and clang::tidy::readability::StyleNames.

The documentation for this class was generated from the following files:

- IdentifierNamingCheck.h
- IdentifierNamingCheck.cpp